/*
 *	Thrading Library by Parra Studios
 *	A threading library providing utilities for lock-free data structures and more.
 *
 *	Copyright (C) 2016 - 2022 Vicente Eduardo Ferrer Garcia <vic798@gmail.com>
 *
 *	Licensed under the Apache License, Version 2.0 (the "License");
 *	you may not use this file except in compliance with the License.
 *	You may obtain a copy of the License at
 *
 *		http://www.apache.org/licenses/LICENSE-2.0
 *
 *	Unless required by applicable law or agreed to in writing, software
 *	distributed under the License is distributed on an "AS IS" BASIS,
 *	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *	See the License for the specific language governing permissions and
 *	limitations under the License.
 *
 */

#ifndef THREADING_THREAD_ID_H
#define THREADING_THREAD_ID_H 1

/* -- Headers -- */

#include <threading/threading_api.h>

#ifdef __cplusplus
extern "C" {
#endif

/* -- Headers -- */

#include <stdint.h>

/* -- Definitions -- */

#define THREAD_ID_INVALID UINT64_MAX

/* -- Macros -- */

/**
*  @brief
*    Return the current thread id depending on the platform
*
*  @return
*    Curent thread id casted to an uint64_t
*/
THREADING_API uint64_t thread_id_get_current(void);

#ifdef __cplusplus
}
#endif

#endif /* THREADING_THREAD_ID_H */
